load("@ytt:data", "data")
load("@ytt:assert", "assert")

mgmt_config_secret_name = "cluster-autoscaler-mgmt-config-secret"
mgmt_config_secret_key = "value"

# Namesapce where cluster autosclaer will be running
namespace = "kube-system"

# return management config secret name
def get_mgmt_config_secret_name():
    return mgmt_config_secret_name

end

# return the management config key name in the secret
def get_mgmt_config_secret_key():
    return mgmt_config_secret_key

end

def get_namesapce():
    return namespace

end

def get_node_selector():
    return {
        "node-role.kubernetes.io/control-plane": "",
    }

end

def get_tolerations():
    return [
        {
            "effect": "NoSchedule",
            "key": "node-role.kubernetes.io/control-plane",
            "operator": "Exists",
        },
        {
            "key": "CriticalAddonsOnly",
            "operator": "Exists",
        },
        {
            "effect": "NoSchedule",
            "key": "kubeadmNode",
            "operator": "Equal",
            "value": "master",
        },
        {
            "effect": "NoExecute",
            "key": "node.kubernetes.io/not-ready",
            "operator": "Exists",
            "tolerationSeconds": 300,
        },
        {
            "effect": "NoExecute",
            "key": "node.kubernetes.io/unreachable",
            "operator": "Exists",
            "tolerationSeconds": 300,
        },
    ]

end

def get_node_group_auto_discovery(cluster_name, cluster_namesapce):
    return "clusterapi:clusterName={clusterName},namespace={namesapce}".format(clusterName = cluster_name, namesapce = cluster_namesapce)

end

def get_replica_count(paused):
    if paused:
        return 0
    end
    return 1

end

def validate_extra_arguments(extra_args):
    """ This function will validate if the arguments passed in the arguments.extraArguments

    Ex: user can pass max-node-total=3 in extraArguments and set the maxNodesTotal under
    arguments. In this case we need to fail

    Args:
        extra_args: extra arguments
    """
    if extra_args == None:
        return
    end

    # Holds all the default and pre-configured argument and their corresponding recomendation
    default_arguments = {
        "namespace": "can't be configured, defaults to kube-system",
        "address": "configure using metricsPort field in arguments",
        "node-group-auto-discovery": "use clusterConfig to conifgure this",
        "max-nodes-total": "use maxNodesTotal field in arguments",
        "scale-down-delay-after-add": "use scaleDownDelayAfterAdd field in arguments",
        "scale-down-delay-after-delete": "use scaleDownDelayAfterDelete field in arguments",
        "scale-down-delay-after-failure": "use scaleDownDelayAfterFailure field in arguments",
        "scale-down-unneeded-time": "use scaleDownUnneededTime field in arguments",
        "max-node-provision-time": "use maxNodeProvisionTime field in arguments",
        "ignore-daemonsets-utilization": "use ignoreDaemonsetsUtilization field in arguments",
    }

    for argument in extra_args:
        # check if extra argument starts with -- and fail
        if argument.find("--") == 0:
            assert.fail("-- is not required for argument {}".format(argument))
        end

        # Some arguments might not be a key value pair
        key = argument.split("=")[0]
        recommend_text = default_arguments.get(key)
        if recommend_text != None:
            assert.fail("{} argument should not be passed as an extra argument, {}".format(key, recommend_text))
        end
    end

end

validate_extra_arguments(data.values.arguments.extraArguments)
